{  PGL Unit                         }
{  Copyright (c) 1991 AnSoft, Inc.  }
{  Turbo Pascal Interface to PGL    }
{  Turbo Pascal 4.0/5.0/5.5/6.0     }

unit PGL;
{$O+,F+}

interface

{  Constant Data Declarations }
const
{	Page Orientation  constants }
 pgPORTRAIT  =0;
 pgLANDSCAPE =1;

{	Page Size  constants }
 pgHALFPAGE  =0;
 pgFULLPAGE  =1;
 pgSMALLPAGE =2;

{	Device Type  constants}
 pgDOTMATRIX =0;
 pgLASERJET  =1;
 pgPCX       =2;
 pgEPS       =3;

{	Printer ON/OFF definition constants}
  pgOFF =0;
  pgON  =1;

{	Line style definition constants}
  pgLSOLID     = 0;
  pgLHUGEDASH  = 1;
  pgLBIGDASH   = 2;
  pgLMEDDASH   = 3;
  pgLSMALLDASH = 4;
  pgLWIDEDOT   = 5;
  pgLCLOSEDOT  = 6;
  pgLDASHDOT   = 7;
  pgLCENTER    = 8;
		
{	Fill Style Definition constants}
  pgFEMPTY      =0;
  pgFSOLID      =1;
  pgFLINE       =2;
  pgFLTSLASH    =3;
  pgFSLASH      =4;
  pgFBKSLASH    =5;
  pgFLTBKSLASH  =6;
  pgFHATCH      =7;
  pgFXHATCH     =8;
  pgFINTERLEAVE =9;
  pgFWIDEDOT    =10;
  pgFCLOSEDOT   =11;

{       Fill Mode Definition constants }
  pgTRANS       =0;
  pgOPAQ        =1;

{	Text Justification  constants}
 pgLEFT         =0;
 pgCENTER	=1;
 pgRIGHT        =2;
 pgBOTTOM	=0;
 pgTOP          =2;

{	Font Style constants}
 pgSMALL    =0;
 pgSIMPLEX  =1;
 pgDUPLEX   =2;
 pgTRIPLEX  =3;
 pgGOTHIC   =4;
 pgSCRIPT   =5;
 pgSDUPLEX  =6;
      	      
{	Fill Flag constants}
 pgOUTLINE =1;
 pgFILL    =2;
 pgOFILL   =3;       

{ Function/Procedure Declarations }
procedure	_pgCreateFile;
procedure	_pgCloseFile;
procedure	_pgWriteFile;
procedure	_pgTellFile;
procedure	_pgSeekFile;
procedure	_pgReadFile;
procedure	_pgOpenFile;
procedure	_pgRawFile;
procedure	_pgiimull;
procedure	_pglidivi;
 
{ Printer Driver Device Info }
function  pgLoadDevInfo  ( name : string ) : integer ;

{ Functions to Set Printer Driver Params }
procedure pgSetPageMargins  ( left, top, right, bot : integer );
procedure pgSetPageForm     ( form : integer );
procedure pgSetPageSize     ( size : integer);

{ Functions To Get Info About Current Driver }
function  pgGetDevModes     : integer ;
function  pgGetDevColors    ( res : integer ) : integer;
function  pgGetDevMaxX      ( res : integer ) : integer;
function  pgGetDevMaxY      ( res : integer ) : integer;
function  pgGetDevResX      ( res :integer):integer;
function  pgGetDevResY      ( res :integer):integer;
function  pgGetDevType      :integer;  
function  pgGetDevHeight    :integer;
function  pgGetDevWidth     :integer;
function  pgGetDevPlanes    ( res : integer):integer;
function  pgGetDevOffsetX   :integer;
function  pgGetDevOffsetY   :integer;

{ Functions to Save Bitmaps }
procedure pgBMInit          ( x, y, width, height, bpp, rle : integer );
procedure pgBMData          ( row : integer; var data );
procedure pgBMEnd           ;

{ PGL System Functions  }
procedure pgInitDrw         ( fname: string; width, height : integer; var err : integer );
procedure pgOpenDrw         ( fname: string; var err: integer );  
procedure pgClearDrw        ( var err : integer );
procedure pgEndDrw          ;
procedure pgNewPage         ;
function  pgGetStatus       :integer;

{ PGL Graphics Functions  }
procedure pgMoveTo          ( x, y :integer );
procedure pgMoveRel         ( x, y :integer );
procedure pgLineTo          ( x, y :integer );
procedure pgLineRel         ( x, y :integer );
procedure pgLine            ( x1, y1, x2, y2 :integer );
procedure pgSetPixel        ( x, y, color : integer );
procedure pgArc             ( x, y, rad, sa, ea :integer);
procedure pgEllArc          ( x, y, radx, rady, sa, ea :integer);
procedure pgPie             ( x,y,rad,sa,ea,fillflag : integer );
procedure pgSector          ( x,y,radx,rady,sa,ea,fillflag : integer );
procedure pgRectangle       ( x1,y1,x2,y2, fillflag : integer );
procedure pgCircle          ( x,y,rad,fillflag : integer );
procedure pgEllipse         ( x,y,radx,rady,fillflag : integer );
procedure pgPolygon         ( var polydata; numpoints,fillflag : integer );
procedure pgPolyLine        ( var polydata; numpoints : integer );
procedure pgDrawText        ( str : string );
procedure pgDrawTextXY      ( x,y : integer; str : string );
procedure pgClearViewPort   ;

{ PGL Functions to Set Graphics Parameters }
procedure pgSetColor        ( color:integer );
procedure pgSetPalette      ( index, color:integer );
procedure pgSetRgbPalette   ( index, red, green, blue:integer );
procedure pgSetDefaults     ;
procedure pgSetFillMode     ( mode :integer);
procedure pgSetFillStyle    ( style, color :integer);
procedure pgSetFillPattern  ( var style; color:integer );
procedure pgSetLineStyle    ( style,thick:integer );
procedure pgSetLineWeight   ( weight:integer );
procedure pgSetLinePattern  ( pat,thick :integer );
procedure pgSetTextBolding  ( thick :integer );
procedure pgSetCharSpacing  ( space :integer );
procedure pgSetTextScaling  ( multx,divx,multy,divy :integer );
procedure pgSetTextJustify  ( horiz,vert :integer );
procedure pgSetTextOrient   ( ox,oy :integer );
procedure pgSetTextStyle    ( fontno :integer );
procedure pgSetClipArea     ( cx1,cy1,cx2,cy2 :integer );
procedure pgSetClipping     ( flag :integer );
procedure pgSetPrn          ( flag :integer );
procedure pgSetViewPort     ( x1,y1,x2,y2 :integer );

{ PGL Functions to Get Graphics Parameters }
function  pgGetColor        :integer;
function  pgGetFillMode     :integer;
procedure pgGetFillPattern  ( var style;  var color:integer );
procedure pgGetFillStyle    ( var style,color :integer );
procedure pgGetLinePattern  ( var pat,thick   :integer );
function  pgGetLineWeight   :integer ;
function  pgGetMaxX         :integer ;
function  pgGetMaxY         :integer ;
function  pgGetTextBolding  :integer ;
function  pgGetCharSpacing  :integer ;
procedure pgGetTextScaling  ( var multx,divx,multy,divy:integer );
procedure pgGetTextJustify  ( var horiz,vert:integer );
procedure pgGetTextOrient   ( var ox, oy:integer );
function  pgGetTextStyle    :integer ;
procedure pgGetClipArea     ( var cx1,cy1,cx2,cy2:integer );
function  pgGetClipping     :integer;
function  pgGetPrn          :integer;
function  pgGetTextHeight   :integer;
function  pgGetX            :integer;
function  pgGetY            :integer;
function  pgGetAbsX         :integer;
function  pgGetAbsY         :integer;
function  pgGetTextLength   ( str : string ):integer;
procedure pgGetViewPort     ( var x1,y1,x2,y2 :integer );
implementation

{$L PGL_TP.OBJ  }  { link in pgl object module }

function  pgLoadDevInfo     ;external;
procedure pgSetPageMargins  ;external;
procedure pgSetPageForm     ;external;
procedure pgSetPageSize     ;external;
function  pgGetDevModes     ;external;
function  pgGetDevColors    ;external;
function  pgGetDevMaxX      ;external;
function  pgGetDevMaxY      ;external;
function  pgGetDevResX      ;external;
function  pgGetDevResY      ;external;
function  pgGetDevType      ;external;
function  pgGetDevHeight    ;external;
function  pgGetDevWidth     ;external;
function  pgGetDevPlanes    ;external;
function  pgGetDevOffsetX   ;external;
function  pgGetDevOffsetY   ;external;
procedure pgBMInit          ;external;
procedure pgBMData          ;external;
procedure pgBMEnd           ;external;
procedure pgInitDrw         ;external;
procedure pgOpenDrw         ;external;
procedure pgClearDrw        ;external;
procedure pgEndDrw          ;external;
procedure pgNewPage         ;external;
function  pgGetStatus       ;external;
procedure pgMoveTo          ;external;
procedure pgMoveRel         ;external;
procedure pgLineTo          ;external;
procedure pgLineRel         ;external;
procedure pgLine            ;external;
procedure pgSetPixel        ;external;
procedure pgArc             ;external;
procedure pgEllArc          ;external;
procedure pgPie             ;external;
procedure pgSector          ;external;
procedure pgRectangle       ;external;
procedure pgCircle          ;external;
procedure pgEllipse         ;external;
procedure pgPolygon         ;external;
procedure pgPolyLine        ;external;
procedure pgDrawText        ;external;
procedure pgDrawTextXY      ;external;
procedure pgClearViewPort   ;external;
procedure pgSetColor        ;external;
procedure pgSetPalette      ;external;
procedure pgSetRgbPalette   ;external;
procedure pgSetDefaults     ;external;
procedure pgSetFillMode     ;external;
procedure pgSetFillStyle    ;external;
procedure pgSetFillPattern  ;external;
procedure pgSetLineStyle    ;external;
procedure pgSetLineWeight   ;external;
procedure pgSetLinePattern  ;external;
procedure pgSetTextBolding  ;external;
procedure pgSetCharSpacing  ;external;
procedure pgSetTextScaling  ;external;
procedure pgSetTextJustify  ;external;
procedure pgSetTextOrient   ;external;
procedure pgSetTextStyle    ;external;
procedure pgSetClipArea     ;external;
procedure pgSetClipping     ;external;
procedure pgSetPrn          ;external;
procedure pgSetViewPort     ;external;
function  pgGetColor        ;external;
function  pgGetFillMode     ;external;
procedure pgGetFillPattern  ;external;
procedure pgGetFillStyle    ;external;
procedure pgGetLineStyle    ;external;
function  pgGetLineWeight   ;external;
procedure pgGetLinePattern  ;external;
function  pgGetMaxX         ;external;
function  pgGetMaxY         ;external;
function  pgGetTextBolding  ;external;
function  pgGetCharSpacing  ;external;
procedure pgGetTextScaling  ;external;
procedure pgGetTextJustify  ;external;
procedure pgGetTextOrient   ;external;
function  pgGetTextStyle    ;external;
procedure pgGetClipArea     ;external;
function  pgGetClipping     ;external;
function  pgGetPrn          ;external;
function  pgGetTextHeight   ;external;
function  pgGetX            ;external;
function  pgGetY            ;external;
function  pgGetAbsX         ;external;
function  pgGetAbsY         ;external;
function  pgGetTextLength   ;external;
procedure pgGetViewPort     ;external;

{$L PGLIO.OBJ  }  { link in pgl I/O object module }
procedure	_pgCreateFile ;external;
procedure	_pgCloseFile  ;external;
procedure	_pgWriteFile  ;external;
procedure	_pgTellFile   ;external;
procedure	_pgSeekFile   ;external;
procedure	_pgReadFile   ;external;
procedure	_pgOpenFile   ;external;
procedure	_pgRawFile    ;external;
procedure	_pgiimull     ;external;
procedure	_pglidivi     ;external;
   
end.
