{ TESTDEV.PAS }
{ PGL - Turbo Pascal Test Program }

program testdev;
{$R-,S-}
uses Crt, PGL;

label
ExitPgm;

const
  port = pgPORTRAIT;
  psize= pgHALFPAGE;
  name   : String[20] = 'HPLJET';
  dfile  : String[20] = 'testdev.plt';

{type}

var
  i, j, ierr, ncolors, res, maxX, maxY, nres : integer;
  dwidth, dheight, dpix, dpiy, nplanes, dtype, pox, poy: integer;

{ ****   TestDev main procedure   ****  }
begin
  ierr := pgLoadDevInfo ( name );
  if  ierr <> 0 then
    begin
       Write('Err=',ierr ); 
       goto ExitPgm;
    end;

{ Select Page formatting/size options. }
{ This must be done prior to calling pgGetDevMaxX,pgGetDevMaxY }

    pgSetPageMargins  ( 100,100,100,100);  
    pgSetPageForm     ( port  ); 
    pgSetPageSize     ( psize );  

{    Get General Device Info   }
	
    nres    := pgGetDevModes;
    dtype   := pgGetDevType;       
    dheight := pgGetDevHeight;   
    dwidth  := pgGetDevWidth;    
    pox     := pgGetDevOffsetX;  
    poy     := pgGetDevOffsetY; 

    Writeln(  ' Device Parameters-----'); 
    Writeln(  ' No. Of Res Modes: ',nres ); 
    Writeln(  '         Dev Type: ',dtype );  
    Writeln(  '       Dev Height: ',dheight);   
    Writeln(  '        Dev Width: ',dwidth ); 
    Writeln(  '     Dev Offset-X: ',pox ); 
    Writeln(  '     Dev Offset-Y: ',poy );  

    Writeln ;

{  Get Resolution Dependent Device Info, on highest res supported }
	
    res      := nres -1 ;
    dpix     := pgGetDevResX ( res ); 
    dpiy     := pgGetDevResY ( res ); 
    nplanes  := pgGetDevPlanes ( res );  
    ncolors  := pgGetDevColors ( res );  
    maxX     := pgGetDevMaxX ( res ); 
    maxY     := pgGetDevMaxY ( res ); 

    Writeln( ' Resolution Dependent Device Parameters----'); 
    Writeln( '           RES: ',res  ); 
    Writeln( '         DPI-X: ',dpix );  
    Writeln( '         DPI-Y: ',dpiy );  
    Writeln( ' No. Of Planes: ',nplanes );  
    Writeln( ' No. Of Colors: ',ncolors );  
    Writeln( '          MaxX: ',maxX ); 
    Writeln( '          MaxY: ',maxY );  

   { Open A Drawing File, set size to the exact physical device/page  }
   { specific dwidth and dheight dimensions.  Now your working in hardware }
   { coordinates. }
	
   pgInitDrw( dfile, maxX+1, maxY+1, ierr ); 
   if ierr > 0 then
        Writeln(' Error Opening a Drawing File =',ierr);

   if ncolors = 2 then
       {  Black Pen on white paper for B&W a printer  }
       pgSetColor(1)
   else
       {  Black Pen on White paper on Color a printer  }
       pgSetColor(0); 
   pgRectangle( 0,  0, maxX, maxY , pgOUTLINE );  
   pgRectangle(20, 20, maxX -20, maxY -20, pgOUTLINE );  

   pgSetTextStyle( pgTRIPLEX ); 
   pgSetTextJustify( pgCENTER, pgCENTER ); 
   pgSetTextScaling( 5,1,5,1 ); 
   pgDrawTextXY( maxX DIV 2, maxY DIV 2, 'Hello World' ); 

   { Close The Drawing File. }
   pgEndDrw ;
ExitPgm:
end.
